﻿Imports System
Imports System.IO
Imports System.Windows.Forms
Imports System.Data.SqlClient
Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition

' http://www.vbdotnetheaven.com/UploadFile/mahesh/CreateSQLDatabase04252005064419AM/CreateSQLDatabase.aspx

Public Class Form1

    ' CHANGE THIS TO MATCH THE SERVER NAME!
    Private ServerName As String = "CM"

    ' CHANGE THIS TO MATCH THE INSTANCE NAME!
    Private InstanceName As String = "SQLExpress"

    Private ConnectionString As String = "Integrated Security=SSPI;" + "Initial Catalog=;" + "Data Source=" & ServerName & "\" & InstanceName & ";"
    Private connectString As String = "Integrated Security=SSPI;" + "Initial Catalog=Vessels4;" + "Data Source=" & ServerName & "\" & InstanceName & ";"
    Private reader As SqlDataReader = Nothing
    Private conn As SqlConnection = Nothing
    Private cmd As SqlCommand = Nothing
    Private sql As String = Nothing
    Private button1 As System.Windows.Forms.Button
    Dim staticOverlay As New LayerOverlay()
    Dim WorldCountriesLayer As New ShapeFileFeatureLayer("C:\Program Files (x86)\ThinkGeo\Map Suite Desktop Full Edition 4.0\Samples\SampleData\Data\Countries02.shp")
    Dim WorldCitiesLayer As New ShapeFileFeatureLayer("C:\Program Files (x86)\ThinkGeo\Map Suite Desktop Full Edition 4.0\Samples\SampleData\Data\WorldCapitals.shp")
    Dim sql2008VesselsLayer As New MsSql2008FeatureLayer(connectString, "Vessels4", "ID") ' should this be the key layer ID or the geometry layer WGS84Loc?

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' Check that SQL Server is running and if so, make a connection to it.
        ' Create a connection
        conn = New SqlConnection(ConnectionString)
        ' Open the connection
        If conn.State <> ConnectionState.Open Then
            Try
                conn.Open()
            Catch ae As SqlException
                Debug.WriteLine(ae.ErrorCode.ToString)  ' -2146232060
                Debug.WriteLine(ae.Message.ToString())  ' A network-related or instance-specific error occurred while establishing a connection to SQL Server. The server was not found or was not accessible. Verify that the instance name is correct and that SQL Server is configured to allow remote connections. (provider: SQL Network Interfaces, error: 26 - Error Locating Server/Instance Specified)
                If ae.ErrorCode = -2146232060 Then
                    MessageBox.Show("Cannot connect to " & ServerName & "\" & InstanceName & vbCrLf & "Application will end.", "TestSQLServer3 Error")
                    End
                End If
            End Try
        End If

        ' Load in world map so we have a sense of scale.
        LoadWorldMap()
        CreateDB()
        CreateTable()
        LoadSQL2008Layers()

    End Sub

    Sub LoadWorldMap()

        WinformsMap1.MapUnit = GeographyUnit.DecimalDegree

        ' Make ocean blue
        WinformsMap1.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean)

        ' Set the worldLayer with a preset Style, as AreaStyles.Country1 has YellowGreen background and black border, our worldLayer will have the same render style.  
        WorldCountriesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1
        WorldCitiesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1

        ' This setting will apply from ZoonLevel01 to ZoomLevel20, that means we can see the world the same style with ZoomLevel01 all the time no matter how far we zoom out/in. 
        WorldCountriesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        WorldCitiesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

        ' How do we get the labels displayed?
        WorldCitiesLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.City1
        WorldCitiesLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.City1("ADMIN_NAME") ' ADMIN_NAME for WorldCapitals, AREANAME for USA major cities
        WorldCitiesLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.PointPlacement = PointPlacement.LowerCenter ' make user definable?
        WorldCitiesLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.OverlappingRule = LabelOverlappingRule.NoOverlapping ' make user definable?
        WorldCitiesLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.BestPlacement = True

        Dim staticOverlay As New LayerOverlay()
        staticOverlay.Layers.Add(WorldCountriesLayer)
        staticOverlay.Layers.Add("WorldCitiesLayer", WorldCitiesLayer)
        WinformsMap1.Overlays.Add(staticOverlay)

    End Sub


    Private Sub ExecuteSQLStmt(ByVal sql As String)

        Debug.Print(sql)

        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        conn.ConnectionString = ConnectionString
        conn.Open()
        cmd = New SqlCommand(sql, conn)
        Try
            cmd.ExecuteNonQuery()
            Debug.Print(cmd.CommandText)
        Catch ae As SqlException
            Debug.Print("Recoverable crash in ExecuteSQLStmt")
            MessageBox.Show(ae.Message.ToString())
        End Try

    End Sub 'ExecuteSQLStmt 

    Private Sub AppExit()
        If Not (reader Is Nothing) Then
            reader.Close()
        End If
        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
    End Sub 'AppExit

    Private Sub CreateDB()

        'This method creates a new SQL Server database if it exists, or deletes it if it already exists.

        Dim sql As String

        ' I need to change maxsize=5 to something else
        ' http://support.powerdnn.com/index.php?_m=knowledgebase&_a=viewarticle&kbarticleid=143
        ' Note that max size if 4GB! How long will that last? More than 1 year?
        sql = "CREATE DATABASE Vessels4 ON PRIMARY" + "(Name=test_data, filename = 'C:\mysql\Vessels4_data.mdf', size=3," + "maxsize=5, filegrowth=10%)log on" + "(name=Vessels4b_log, filename='C:\mysql\Vessels4_log.ldf',size=3," + "maxsize=20,filegrowth=1)"
        ExecuteSQLStmt(sql)

    End Sub

    Private Sub CreateTable() ' Btn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateTableBtn.Click

        Dim cownt As Integer
        Dim cownt1 As Integer
        Dim cownt2 As Integer

        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        conn.ConnectionString = connectString
        conn.Open()
        sql = "CREATE TABLE Vessels4" + "(ID INTEGER CONSTRAINT PKeyMyId PRIMARY KEY, " + "Name CHAR(254), UseMe BIT, VLat FLOAT, VLon FLOAT, VDateTime datetime, VSpd FLOAT, VCMG FLOAT, MaxSpeedEver FLOAT, WGS84Loc Geography)"
        cmd = New SqlCommand(sql, conn)
        Try
            cmd.ExecuteNonQuery()
        Catch ae As SqlException
            MessageBox.Show(ae.Message.ToString())
            Exit Sub
        End Try

        For cownt = -89 To 89
            cownt1 = cownt + 90
            cownt2 = -cownt
            sql = "INSERT INTO Vessels4(ID, Name, UseMe, VLon, VLat, VCMG, VDateTime, WGS84Loc) " + "VALUES (0" + cownt1.ToString("000") + ", 'Vessel " + cownt1.ToString + "a', 1, " + (1 * cownt).ToString + ", " + cownt.ToString + ", " + cownt.ToString + ", '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + (1 * cownt).ToString + " " + cownt.ToString + ")') "
            Debug.Print(sql)
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
            sql = "INSERT INTO Vessels4(ID, Name, UseMe, VLon, VLat, VCMG, VDateTime, WGS84Loc) " + "VALUES (1" + cownt1.ToString("000") + ", 'Vessel " + cownt1.ToString + "b', 1, " + (1 * cownt).ToString + ", " + cownt.ToString + ", " + cownt.ToString + ", '" + DateTime.UtcNow.ToString("s") + "', 'POINT(" + (1 * cownt).ToString + " " + cownt2.ToString + ")') "
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
        Next
        MessageBox.Show("CreateTableBtn_Click done")

    End Sub

    Private Sub ViewDataBtn_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewDataBtn.Click

        ' How to: Add an Unbound Column to a Data-Bound Windows Forms DataGridView Control
        ' http://msdn.microsoft.com/en-us/library/zkatshfa.aspx

        Dim UpdateRxedCol As New DataGridViewButtonColumn

        With UpdateRxedCol
            .HeaderText = "Updated Rxed"
            .Name = "UpdateRxedCol"
            .Text = "Update Text"

            .UseColumnTextForButtonValue = True
        End With

        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        conn.ConnectionString = connectString
        conn.Open()

        ' DISPLAY THE DATA IN THE GRID
        ' Create a data adapter
        Dim da As New SqlDataAdapter("SELECT * FROM Vessels4 ORDER BY VDateTime DESC", conn)
        ' Create DataSet, fill it and view in data grid
        Dim ds As New DataSet("Vessels4")
        da.Fill(ds, "Vessels4")
        DataGrid1.DataSource = ds.Tables("Vessels4").DefaultView
        DataGrid1.Columns.Insert(2, UpdateRxedCol) ' this adds an umbound column defined above

        ' refresh the grid
        DataGrid1.EndEdit()
        DataGrid1.Refresh()

    End Sub

    Private Sub btnChangePositions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChangePositions.Click

        Dim cownt As Integer

        Dim SQLString As String

        Dim MaxLat As Double = 10
        Dim MinLat As Double = -MaxLat
        Dim MaxLon As Double = 10
        Dim MinLon As Double = -MaxLon

        If conn.State = ConnectionState.Open Then
            conn.Close()
        End If
        conn.ConnectionString = connectString
        conn.Open()

        ' Change the positions of the spatial data in the table.
        ' We have ID of 0 to 180 and 1000 to 1180
        For cownt = 0 To 180
            SQLString = "'POINT(" + (MinLon + Rnd() * (2 * MaxLon)).ToString + " " + (MinLat + Rnd() * (2 * MaxLat)).ToString + ")'"
            sql = "UPDATE Vessels4 SET WGS84Loc=" + SQLString + ", VCMG=" + cownt.ToString + " WHERE ID=" + cownt.ToString
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
        Next
        For cownt = 1000 To 1180
            SQLString = "'POINT(" + (MinLon + Rnd() * (2 * MaxLon)).ToString + " " + (MinLat + Rnd() * (2 * MaxLat)).ToString + ")'"
            sql = "UPDATE Vessels4 SET WGS84Loc = " + SQLString + ", VCMG=" + (-1000 + cownt).ToString + " WHERE ID=" + cownt.ToString
            cmd = New SqlCommand(sql, conn)
            cmd.ExecuteNonQuery()
        Next

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Timer1.Enabled = False

        ' refresh the grid
        DataGrid1.EndEdit()
        DataGrid1.Refresh()

        ' refresh the map
        Try
            WinformsMap1.Refresh()
        Catch ae As Exception
            Debug.Print(Now().ToString + " - Timer1_Tick(): " + ae.Message.ToString())
            'Stop
        End Try

        Try
            txtVesselCount.Text = sql2008VesselsLayer.QueryTools.GetCount
        Catch ae As SqlException
            If InStr(ae.Message.ToString, "was deadlocked on lock resources with another process and has been chosen as the deadlock victim. Rerun the transaction.") > 0 Then
                ' ignore this - we have a message that looks like this:
                ' Transaction (Process ID 60) was deadlocked on lock resources with another process and has been chosen as the deadlock victim. Rerun the transaction.
                ' (Will this cause problems? Will we be forever stuck in a loop? Or will it work sometimes?
            Else
                Debug.Print(ae.Message.ToString)
                MessageBox.Show(ae.Message.ToString())
                Stop
            End If
        End Try

        Debug.Print(Now() + ": Timer enabled")

        Timer1.Enabled = True

    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged

    End Sub

    Private Sub LoadSQL2008Layers()

        ' Something strange here - we seem to have 3 different locations for a point.
        ' 1) Small red dot - highest
        ' 2) Center of label
        ' 3) Center (or any part) of vessel icon

        WinformsMap1.MapUnit = GeographyUnit.DecimalDegree

        WinformsMap1.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean)

        sql2008VesselsLayer.Srid = 4326
        'sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.SymbolPen = New GeoPen(GeoColor.FromArgb(255, GeoColor.StandardColors.Red), 5)
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.Capital3 ' this puts a red dot ABOVE the center of the point - marks the exact spot?

        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.PointType = PointType.Character
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.CharacterFont = New GeoFont("Webdings", 20)
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.CharacterIndex = 111
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.CharacterSolidBrush = New GeoSolidBrush(GeoColor.StandardColors.Red)               ' ship symbol colour
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.SymbolPen = New GeoPen(GeoColor.FromArgb(255, GeoColor.StandardColors.Black), 1)   ' symbol outline colour and thickness
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.City1("ID")
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.PointPlacement = PointPlacement.Center
        'sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.LabelPositions.
        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.OverlappingRule = LabelOverlappingRule.NoOverlapping


        sql2008VesselsLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

        Dim staticOverlay As New LayerOverlay()
        staticOverlay.Layers.Add("Sql2008VesselsLayer", sql2008VesselsLayer)
        WinformsMap1.Overlays.Add(staticOverlay)

        sql2008VesselsLayer.Open()
        sql2008VesselsLayer.Close()

    End Sub

    Private Sub Form1_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

        WinformsMap1.CurrentExtent = New RectangleShape(-18, 9, 18, -9)
        WinformsMap1.Refresh()
        ' maybe enable timer here?

    End Sub

End Class
